# Contributing to Ploty.rs

Contribution in the form of suggestions, bug reports, pull requests and feedback is welcome from everyone. In this document you'll find guidance if you are considering to offer your help to this project.

## Submitting Bug Reports and Feature Requests

When reporting a bug or asking for help, please include enough details so that the people helping you can reproduce the behavior you are seeing. For some tips on how to approach this, read about how to produce a [Minimal, Complete, and Verifiable example].

[Minimal, Complete, and Verifiable example]: https://stackoverflow.com/help/mcve

When making a feature request, please make it clear what problem you intend to solve with the feature, any ideas for how  Plotly.rs could support solving that problem, any possible alternatives, and any disadvantages.

## Pull Requests

Before spending time and effort in making changes to the library, it's a good idea to discuss it first on the issue tracker to see whether your change is likely to be accepted. 

Fork [plotly](https://igiagkiozis.github.io/plotly/) to your own account and create a new branch for your feature. Remember to update the [changelog](CHANGELOG.md) - use previous entries as a template. 

When your contribution is ready for review, make a pull request with your changes directly to the `master` branch. One of the maintainers will have a look at what you've done, suggest any necessary changes and, when everyone is happy, merge the pull request.

## Code of Conduct

In all forums, we follow the [Rust Code of Conduct]. For escalation or moderation issues please contact Ioannis (i.giagkiozis@gmail.com) instead of the Rust moderation team.

[Rust Code of Conduct]: https://www.rust-lang.org/conduct.html

## Attribution

Parts of this document are adapted from the [serde](https://github.com/serde-rs/serde) contributing guide.